<?php

include_spip('base/serial'); // pour eviter une reinit posterieure des tables modifiees

$produits = array(
        'id_article'       => 'bigint(21) NOT NULL',
        'ref_produit'      => 'tinytext',
        'nom_com'          => 'tinytext',
        'don'              => 'tinyint(1) NOT NULL DEFAULT 0',
        'prix_unitaire_ht' => 'float NOT NULL DEFAULT 0.0',
        'tva'              => 'float NOT NULL DEFAULT 0.0'
		);

$produits_keys = array(
		"PRIMARY KEY"	=> "id_article"
		);
//---------------------------

$versements = array(
        'id_versement'     => 'bigint(21) NOT NULL',
        'item_number'      => 'tinytext',  //ref_produit, mais pas forcment, correspond au champ paypal du meme nom
                                           //devra correspondre  un idnetifiant de facture
        'id_auteur'        => 'bigint(21) NOT NULL default 0',
        'versement_ht'     => 'FLOAT not null default 0.0', //mc_gross
        'versement_taxes'  => 'FLOAT not null default 0.0', //mc_tax
        'versement_charges' => 'FLOAT not null default 0.0', //mc_fees
        'id_devise'        => "varchar(3) not null default 'EUR'",
        'date_versement'   => "datetime DEFAULT '0000-00-00 00:00:00' NOT NULL",
        'servi'            => 'tinyint(1) NOT NULL DEFAULT 0', //les actions lies au versement ont elles t effectues ?
        'notification'     => 'text' //on sauvegarde la notification reu de PayPal
		);

$versements_keys = array(
		"PRIMARY KEY"	=> "id_versement"
		);

//-- Tables principales ----------------------------------------------------------------
global $tables_principales;
$tables_principales['spip_gopaypal_produits'] =
	array('field' => &$produits, 'key' => &$produits_keys);
$tables_principales['spip_gopaypal_versements'] =
	array('field' => &$versements, 'key' => &$versements_keys);

//-- Tables auxiliaires ----------------------------------------------------------------
global $tables_auxiliaires;

global $exceptions_des_tables;

global $table_primary;

global $table_date;

// si on declare les tables dans $table_des_tables, il faut mettre le prefixe
// 'spip_' dans l'index de $tables_principales
global $table_des_tables;
$table_des_tables['gopaypal_produits']                = 'gopaypal_produits';
$table_des_tables['gopaypal_versements']              = 'gopaypal_versements';

//-- Jointures ----------------------------------------------------
global $tables_jointures;

global $exceptions_des_jointures;


?>