<?php

define('AV_ERREUR_CONNEXION_PAYPAL',   1);
define('AV_ERREUR_VALIDATION_INVALID', 2);

//file_put_contents('paypal.log', "----------------------------------------------------\r\n");
//file_put_contents('paypal.log', print_r($_REQUEST, true)."\r\n", FILE_APPEND);

function validation_pp_http_post() {
    $body   = validation_pp_http_body();
    $header = validation_pp_http_header(strlen($body));

    $url = lire_config('gopaypal_paypal/notify_url');
    $fp = fsockopen ($url, 80, $errno, $errstr, 30);
    if (!$fp) {
        validation_pp_http_ERREUR(AV_ERREUR_CONNEXION_PAYPAL);
    } else {
//file_put_contents('paypal.log', "----------------------------\r\n$header$body\r\n", FILE_APPEND);
        fputs ($fp, $header . $body);
        $res = '';
        while (!feof($fp)) {
            $res .= fgets ($fp, 1024);
        }
//file_put_contents('paypal.log', "----------------------------\r\n$res", FILE_APPEND);
        if (strpos ($res, "VERIFIED") != 0) {
            validation_pp_http_VERIFIED();
        }
        else {
            if (strpos ($res, "INVALID") != 0) {
                validation_pp_http_INVALID();
            }
        }
        fclose ($fp);
    }
}

function validation_pp_http_body() {
    $body = 'cmd=_notify-validate';
    foreach ($_REQUEST as $key => $value) {
        $value = urlencode(stripslashes($value));
        $body .= "&$key=$value";
    }
   
    return $body;
}

function validation_pp_http_header($length) {
    $header = "POST /cgi-bin/webscr HTTP/1.0\r\n";
    $header .= "Content-Type: application/x-www-form-urlencoded\r\n";
    $header .= "Content-Length: " . $length . "\r\n\r\n";
    
    return $header;
}

function validation_pp_http_VERIFIED() {
    //on a reu du serveur paypal un message comportant VERIFIED, la transaction est valide ET les donnes
    //transmises sont considres comme sures.
    if ( $_REQUEST['payment_status'] == 'Completed' ) {
        include_spip('base/abstract_sql');
        $custom = unserialize($_REQUEST['custom']);
        $notification = '';
        if ( lire_config('gopaypal_paypal/garder_notification') )
            $notification = serialize($_REQUEST);
        spip_abstract_insert(
            "spip_gopaypal_versements",
            "(item_number, id_auteur, versement_ht, versement_taxes, versement_charges, id_devise, date_versement, notification)",
            $values = "('".$_REQUEST['item_number']."',".
                $custom['id_auteur'].",".
                ((($_REQUEST['payment_gross'])?$_REQUEST['payment_gross']:$_REQUEST['mc_gross']) - $_REQUEST['tax']).",".
                $_REQUEST['tax'].",".
                (($_REQUEST['payment_fee'])?$_REQUEST['payment_fee']:$_REQUEST['mc_fee']).",".
                "'".(($_REQUEST['mc_currency'])?$_REQUEST['mc_currency']:'USD')."',".
                "NOW(),".
                "'".$notification."'".
                ")"
        );
//file_put_contents('paypal.log', "----------------------------\r\n$values", FILE_APPEND);
    }
}

function validation_pp_http_INVALID() {
    validation_pp_http_ERREUR(AV_ERREUR_VALIDATION_INVALID);
}

function validation_pp_http_ERREUR($no_erreur) {
    spip_log("erreur plugin [gopaypal][inc/gopaypal_notification_pp][validation_pp_http][$no_erreur]");
}

?>